#ifndef timer_h
#define timer_h


struct timer
{
    unsigned long long	total_time;
    unsigned		count;
};

extern float Hz, KHz, MHz, GHz;

extern void timer_module_init(void);


__inline__ static unsigned long long rdtsc(void)
{
    unsigned long long time;

    __asm__ __volatile__ ("rdtsc" : "=A" (time));
    return time;
}


__inline__ static void timer_init(struct timer *timer)
{
    timer->total_time = 0;
    timer->count      = 0;
}


__inline__ static void timer_start(struct timer *timer)
{
    timer->total_time -= rdtsc();
}


__inline__ static void timer_stop(struct timer *timer)
{
    timer->total_time += rdtsc();
    timer->count ++;
}


extern void timer_print(struct timer *, const char *name);

#endif
